﻿using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace WCFServiceWebRole1
{
    [ServiceContract]
    public interface IRepositoryService
    {
        [OperationContract]
        int Count();

        [OperationContract]
        int CountFilenames();   

        [OperationContract]
        bool Add(string filename, string host, int port);

        [OperationContract]
        bool Remove(string filename, string host, int port);

        [OperationContract]
        List<Destination> Get(string filename);

        [OperationContract]
        int RemoveAll(string host, int port);

        [OperationContract]
        int AddAll(List<string> filenames, string host, int port);
    }

    [DataContract]
    public class Destination
    {
        [DataMember]
        public string Host { get; set; }

        [DataMember]
        public int Port { get; set; }
    }
}
