﻿using System.Collections.Generic;
using System.Data.SqlClient;

namespace WCFServiceWebRole1
{
    public class RepositoryService : IRepositoryService
    {
        private const string ConnectionString =
            "Server=tcp:hcx0ty48uo.database.windows.net,1433;Database=powernap;User ID=iot@hcx0ty48uo;Password=Secret12;Encrypt=True;TrustServerCertificate=False;Connection Timeout=30;";
        public int Count()
        {
            return SelectSingleInt("select count(filename) from registry");
        }

        public int CountFilenames()
        {
            return SelectSingleInt("select count(distinct filename) from registry");
        }

        private static int SelectSingleInt(string selectQuery)
        {
            using (SqlConnection connection = new SqlConnection(ConnectionString))
            {
                connection.Open();
                SqlCommand command = new SqlCommand(selectQuery, connection);
                using (SqlDataReader reader = command.ExecuteReader())
                {
                    if (reader.HasRows)
                    {
                        reader.Read();
                        return reader.GetInt32(0);
                    }
                    return 0;
                }
            }
        }


        public bool Add(string filename, string host, int port)
        {
            using (SqlConnection connection = new SqlConnection(ConnectionString))
            {
                try
                {
                    connection.Open();
                    SqlCommand command =
                        new SqlCommand("insert into registry (filename, host, port) values (@filename, @host, @port)",
                            connection);
                    command.Parameters.AddWithValue("@filename", filename);
                    command.Parameters.AddWithValue("@host", host);
                    command.Parameters.AddWithValue("@port", port);
                    int rowsAffected = command.ExecuteNonQuery();
                    return rowsAffected > 0;
                }
                catch (SqlException ex)
                {
                    return false;
                }
            }
        }

        // todo Runs, but nothing is deleted!
        public bool Remove(string filename, string host, int port)
        {
            using (SqlConnection connection = new SqlConnection(ConnectionString))
            {
                connection.Open();
                SqlCommand command = new SqlCommand("delete from registry where filename=@filename and host=@host and port=@port", connection);
                command.Parameters.AddWithValue("@filename", filename);
                command.Parameters.AddWithValue("@host", host);
                command.Parameters.AddWithValue("@port", port);
                int rowsAffected = command.ExecuteNonQuery();
                return rowsAffected > 0;
            }
        }

        public List<Destination> Get(string filename)
        {
            List<Destination> result = new List<Destination>();
            using (SqlConnection connection = new SqlConnection(ConnectionString))
            {
                connection.Open();
                using (SqlCommand command = new SqlCommand("select host, port from registry where filename = @filename", connection))
                {
                    command.Parameters.AddWithValue("@filename", filename);
                    using (SqlDataReader reader = command.ExecuteReader())
                    {
                        if (reader.HasRows)
                        {
                            while (reader.Read())
                            {
                                string host = reader.GetString(0);
                                int port = reader.GetInt32(1);
                                Destination destination = new Destination()
                                {
                                    Host = host,
                                    Port = port
                                };
                                result.Add(destination);
                            }
                        }
                    }
                }
            }
            return result;
        }

        public int RemoveAll(string host, int port)
        {
            using (SqlConnection connection = new SqlConnection(ConnectionString))
            {
                connection.Open();
                SqlCommand command = new SqlCommand("delete from registry where host=@host and port=@port", connection);
                command.Parameters.AddWithValue("@host", host);
                command.Parameters.AddWithValue("@port", port);
                int rowsAffected = command.ExecuteNonQuery();
                return rowsAffected;
            }
        }

        public int AddAll(List<string> filenames, string host, int port)
        {
            int howMany = 0;
            foreach (string filename in filenames)
            {
                bool added = Add(filename, host, port);
                if (added) howMany++;
            }
            return howMany;
        }
    }
}
